# remirepo/Fedora spec file for php-zendframework-zend-math
#
# Copyright (c) 2015-2016 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    f4358090d5d23973121f1ed0b376184b66d9edec
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-math
%global php_home     %{_datadir}/php
%global library      Math
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.7.0
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

Group:          Development/Libraries
License:        BSD
URL:            http://framework.zend.com/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.5
BuildRequires:  php-bcmath
BuildRequires:  php-gmp
BuildRequires:  php-openssl
BuildRequires:  php-pcre
BuildRequires:  php-spl
# test suite hangs without (need investigation)
BuildRequires:  php-mcrypt
# From composer, "require-dev": {
#        "fabpot/php-cs-fixer": "1.7.*",
#        "ircmaxell/random-lib": "~1.1",
#        "phpunit/PHPUnit": "~4.0",
#        "zendframework/zend-servicemanager": "~2.5"
BuildRequires:  php-composer(ircmaxell/random-lib)              >= 1.1
BuildRequires:  php-composer(phpunit/phpunit)                   >= 4.0
# Autoloader
BuildRequires:  php-composer(%{gh_owner}/zend-loader) >= 2.5
%endif

# From composer, "require": {
#        "php": "^5.5 || ^7.0"
Requires:       php(language) >= 5.5
# From phpcompatinfo report for version 2.5.2
Requires:       php-openssl
Requires:       php-pcre
Requires:       php-spl
%if ! %{bootstrap}
# From composer, "suggest": {
#        "ext-bcmath": "If using the bcmath functionality",
#        "ext-gmp": "If using the gmp functionality",
#        "ircmaxell/random-lib": "Fallback random byte generator for Zend\\Math\\Rand if Mcrypt extensions is unavailable"
Requires:       php-bcmath
Requires:       php-gmp
# Mandatory as we don't want mcrypt
Requires:       php-composer(ircmaxell/random-lib)
# Autoloader
Requires:       php-composer(%{gh_owner}/zend-loader)           >= 2.5
%endif

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\Math provides general mathematical functions.
So far the supported functionalities are:
* Zend\Math\Rand, a random number generator;
* Zend\Math\BigInteger, a library to manage big integers.


%prep
%setup -q -n %{gh_project}-%{gh_commit}


%build
# Empty build section, nothing required


%install

mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{php_home}/Zend/Loader/AutoloaderFactory.php';
Zend\Loader\AutoloaderFactory::factory(array(
    'Zend\Loader\StandardAutoloader' => array(
        'namespaces' => array(
           'ZendTest\\%{library}' => dirname(__DIR__).'/test/',
           'Zend\\%{library}'     => '%{buildroot}%{php_home}/Zend/%{library}'
))));
require_once '%{php_home}/Zend/autoload.php';
EOF

%{_bindir}/phpunit --include-path=%{buildroot}%{php_home}

%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE.md
%doc CONTRIBUTING.md README.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Fri Apr  8 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- update to 2.7.0
- add mandatory dependency on ircmaxell/random-lib

* Wed Feb  3 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0
- drop dependency on zend-servicemanager

* Thu Dec 17 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- update to 2.5.2
- raise minimal php version to 5.5

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package